// MyController.m
// (C)2001 April by K.Nakagawa

#import "MyController.h"

@implementation MyController

// G[bZ[W̃Zbg
- (void)SetErrMess:(NSString *)inErrMess
{
	if(mErrMess == nil){
		NSBeep();
		mErrMess = [[NSString alloc] initWithString:inErrMess];
	}
}

// G[bZ[W邩𔻒fAȂeLXg\AQuit{^LɂYESŖ߂
- (BOOL)PrepareErrMess
{
	if(mErrMess == nil){
		return NO;
	}else{
		NSButton *theButton = myOKbutton;
		NSTextField *theText = myMessage;

		[theText setStringValue:mErrMess];
		[theButton setEnabled:YES];
		[theButton setTransparent:NO];
		
		[mErrMess release];
		mErrMess = nil;
		
		return YES;
	}
}

// Quit{^ꂽp
- (IBAction)myOKpushed:(id)sender
{
	//I
	[NSApp terminate:self];
}

// Preferencej[Ă΂ꂽp
- (IBAction)myPref:(id)sender
{
	NSTextField *theText = myMessage;
	
	//NSLog(@"MyController.myPref called");
	[theText setStringValue:NSLocalizedString (@"NOT_READY_MENU",@"")];
}

//
- (BOOL)Rename:(NSString *)inOrgName to:(NSString *)inDestName
{
	NSFileManager *theFM = [NSFileManager defaultManager];

	//NSLog(@"Rename:%@ to:%@",inOrgName,inDestName);
	
	//̃t@CȂ폜
	if([theFM fileExistsAtPath:inDestName]){
		if(![theFM removeFileAtPath:inDestName handler:nil]){
			return NO;
		}
	}
	
	return [theFM movePath:inOrgName toPath:inDestName handler:nil];
}

//gzip
- (int)Gzip:(NSString *)inOrgName dir:(NSString *)inDir
{
	NSTask *theTask;
	NSMutableArray *theArgs;
	int theStatus;

	//NSLog(@"Gzip:%@ dir:%@",inOrgName,inDir);

	theTask = [[NSTask alloc] init];
	theArgs = [[NSMutableArray alloc] init];

	NS_DURING
		//"gzip -f XXX.tar"N
		[theTask setCurrentDirectoryPath:inDir];
		[theTask setLaunchPath:@"/usr/bin/gzip"];
		[theArgs addObject:@"-f"];
		[theArgs addObject:inOrgName];
		[theTask setArguments:theArgs];
		[theTask launch];

		[theTask waitUntilExit];
		theStatus = [theTask terminationStatus];
	NS_HANDLER
		theStatus = -1;
	NS_ENDHANDLER

	[theTask release];
	[theArgs release];

	return theStatus;
}

//tar
- (int)Tar:(NSString *)inTarName from:(NSString *)inOrgName dir:(NSString *)inDir
{
	NSTask *theTask;
	NSMutableArray *theArgs;
	int theStatus;

	//NSLog(@"Tar:%@ from:%@ dir:%@",inTarName,inOrgName,inDir);

	theTask = [[NSTask alloc] init];
	theArgs = [[NSMutableArray alloc] init];

	NS_DURING
		//"tar -c -f XXX.tar XXX"N
		[theTask setCurrentDirectoryPath:inDir];
		[theTask setLaunchPath:@"/usr/bin/tar"];
		[theArgs addObject:@"-c"];
		[theArgs addObject:@"-f"];
		[theArgs addObject:inTarName];
		[theArgs addObject:inOrgName];
		[theTask setArguments:theArgs];
		[theTask launch];

		[theTask waitUntilExit];
		theStatus = [theTask terminationStatus];
	NS_HANDLER
		theStatus = -1;
	NS_ENDHANDLER

	[theTask release];
	[theArgs release];

	return theStatus;
}

// C
- (void)MainProcSub
{
	NSTextField *theText = myMessage;
	NSString *theTarName;
	NSString *theTgzName;
	int theStatus;

	//\
	[theText setStringValue:[NSString stringWithFormat:NSLocalizedString (@"PROCESSING",@""),
							[mFileToTGZ lastPathComponent]]];
	[theText displayIfNeeded];

	//.tar߂
	theTarName = [NSString stringWithFormat:@"%@.tar",[mFileToTGZ stringByDeletingPathExtension]];

	//łɂtart@CG[
	if([theTarName caseInsensitiveCompare:mFileToTGZ] == NSOrderedSame){
		[self SetErrMess:[NSString stringWithFormat:NSLocalizedString (@"ALREADY_EXISTS",@""),[theTarName lastPathComponent]]];
		return;
	}

	//tarN
	theStatus = [self Tar:[theTarName lastPathComponent]
					  from:[mFileToTGZ lastPathComponent]
					  dir:[theTarName stringByDeletingLastPathComponent]];
	if(theStatus != 0){
		[self SetErrMess:[NSString stringWithFormat:NSLocalizedString (@"CANT_MAKE",@""),[theTarName lastPathComponent]]];
		return;
	}

	//k\
	[theText setStringValue:[NSString stringWithFormat:NSLocalizedString (@"COMPRESSING",@""),
							[mFileToTGZ lastPathComponent]]];
	[theText displayIfNeeded];

	//gzipN
	theStatus = [self Gzip:[theTarName lastPathComponent]
					  dir:[theTarName stringByDeletingLastPathComponent]];
	if(theStatus != 0){
		[self SetErrMess:[NSString stringWithFormat:NSLocalizedString (@"CANT_COMPRESS",@""),[theTarName lastPathComponent]]];
		return;
	}

	//XXX.tar.gzXXX.tgzɉ
	theTgzName = [NSString stringWithFormat:@"%@.tgz",[theTarName stringByDeletingPathExtension]];
	if(![self Rename:[NSString stringWithFormat:@"%@.gz",theTarName] to:theTgzName]){
		[self SetErrMess:[NSString stringWithFormat:NSLocalizedString (@"CANT_CREATE",@""),[theTgzName lastPathComponent]]];
		return;
	}

	//܂ŗOK
	[theText setStringValue:NSLocalizedString (@"COMPLETE",@"")];
	[theText displayIfNeeded];
	NSBeep();
	[NSThread sleepUntilDate:[NSDate dateWithTimeIntervalSinceNow:1.5]];
}

- (void)MainProc
{
	//Quit{^𖳌
	NSButton *theButton = myOKbutton;
	[theButton setEnabled:NO];
	[theButton setTransparent:YES];
	[theButton displayIfNeeded];

	//G[ȂmF
	if(![self PrepareErrMess]){

		//Ȃ΃Cɓ
		[self MainProcSub];
		[mFileToTGZ release];
		mFileToTGZ = nil;

		//G[ȂG[bZ[WoȂ΁AI
		if(![self PrepareErrMess]){
			[NSApp terminate:self];
		}
	}
}

// t@CI[vvɌĂ΂郁\bh
- (BOOL)application:(NSApplication *)theApplication openFile:(NSString *)filename
{
	//NSLog(@"MyController.application:* openFile:%@ called",filename);

	//t@C
	if(mFileToTGZ != nil){
		//łɏ܂ĂȂ_
		[self SetErrMess:NSLocalizedString (@"ONLY_1_FILE",@"")];
	}else{
		mFileToTGZ = [[NSString alloc] initWithString:filename];
	}

	//łapplicationDidFinishLaunchingsĂȂ珈
	if(mLaunched){
		//tgzC
		[self MainProc];
	}

	return YES;
}

// AvP[VJn̍ŏIiKŌĂ΂郁\bh
- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	//NSLog(@"MyController.applicationDidFinishLaunching called");

	//applicationDidFinishLaunchingĂ΂ꂽ
	mLaunched = YES;

	//t@Cݒ肳ĂȂȂG[
	if(mFileToTGZ == nil){
		[self SetErrMess:NSLocalizedString (@"NO_FILES",@"")];
	}
	
	//tgzC
	[self MainProc];
}

// AvP[VIOɌĂ΂郁\bh
- (void)applicationWillTerminate:(NSNotification *)aNotification
{
	//NSLog(@"MyController.applicationWillTerminate called");

	//tgzt@C̉
	if(mFileToTGZ != nil){
		[mFileToTGZ release];
		mFileToTGZ = nil;
	}

	//G[bZ[W̉
	if(mErrMess != nil){
		[mErrMess release];
		mErrMess = nil;
	}
}
@end

// end of file
